# 目录
[概述](#概述)  
[数据结构实验](#数据该结构实验)  
[参考文献](#参考文献)  

# 概述
本教程可以用于数据结构析的实验课程。  
请读者`务必先阅读` [DS Lab使用手册](app-manual.md)，然后再按照下面的内容完成实验。  

# 数据结构实验

数据结构实验提供了28个实验题目，主要包含28个实验模板，涵盖了线性表、链表、二叉树、图、查找、排序等重要的知识点。在每个实验题目下面包含了相应的实验模板，每个模板可以有针对性的对知识点进行练习，通过使用这些模板根据题目的要求完成实验，就可以对数据结构中的绝大部分的知识进行强化。通过完成这些实验，可以提高编程水平，对以后从事相关方面的研发有很大的帮助作用。  

## 实验题目清单
[实验1 实验环境的使用](#实验1 实验环境的使用)  
[实验2 线性表的顺序表示及插入操作](#实验2 线性表的顺序表示及插入操作)  
[实验3 线性表的顺序表示及删除操作](#实验3 线性表的顺序表示及删除操作)  
[实验4 单链表的插入操作](#实验4 单链表的插入操作)  
[实验5 单链表的删除操作](#实验5 单链表的删除操作)  
[实验6 双向循环链表的插入操作](#实验6 双向循环链表的插入操作)  
[实验7 双向循环链表的删除操作](#实验7 双向循环链表的删除操)  
[实验8 字符串的顺序表示及插入操作](#实验8 字符串的顺序表示及插入操作)  
[实验9 二叉树的先序遍历操作](#实验9 二叉树的先序遍历操作)  
[实验10 二叉树的中序遍历操作](#实验10 二叉树的中序遍历操作)  
[实验11 二叉树的后序遍历操作](#实验11 二叉树的后序遍历操作)  
[实验12 线索二叉树](#实验12 线索二叉树)  
[实验13 赫夫曼树的构造](#实验13 赫夫曼树的构造)  
[实验14 一般树的遍历](#实验14 一般树的遍历)  
[实验15 图的深度优先搜索](#实验15 图的深度优先搜索)  
[实验16 图的广度优先搜索](#实验16 图的广度优先搜索)  
[实验17 拓扑排序](#实验17 拓扑排序)  
[实验18 关键路径](#实验18 关键路径)  
[实验19 最短路径（迪杰斯特拉算法）](#实验19 最短路径（迪杰斯特拉算法）)  
[实验20 最短路径（弗洛伊德算法）](#实验20 最短路径（弗洛伊德算法）)  
[实验21 折半查找](#实验21 折半查找)  
[实验22 二叉排序树的构造](#实验22 二叉排序树的构造)  
[实验23 创建哈希表（线性探测再散列）](#实验23 创建哈希表（线性探测再散列）)  
[实验24 创建哈希表（二次探测再散列）](#实验24 创建哈希表（二次探测再散列）)  
[实验25 创建哈希表（伪随机探测再散列）](#实验25 创建哈希表（伪随机探测再散列）)  
[实验26 冒泡排序](#实验26 冒泡排序)  
[实验27 快速排序](#实验27 快速排序)  
[实验28 堆排序](#实验28 堆排序)

## 实验1 实验环境的使用
建议学时：1学时

**`实验目的`**

- 熟悉数据结构集成实验环境DS Lab的基本使用方法。   
- 掌握线性表的顺序表示。
- 实现线性表的插入操作。


**`实验任务`**

如果是第一次使用DS Lab完成实验，请先阅读[使用手册](./app-manual.md)，这样读者可以学习DS Lab的使用方法，后面的实验按照使用手册供的实验步骤就可以顺利完成。  

按照以下实验模板readme文件中的要求完成实验  
[Lab001](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab001.git) 在[使用手册](./app-manual.md)中有详细的步骤引导读者完成实验。  


## 实验2数据类型运算符和简单输入输出
建议学时：1学时

**`实验目的`**
- 掌握C语言数据类型，了解字符型数据和整型数据的内在关系。
- 掌握对各种数值型数据的正确输入方法。
- 学会使用C的算术运算符，以及包含这些运算符的表达式，特别是自加（++）和自减（--）运算符的使用。

**`实验任务`**  

按照以下实验模板readme文件中的要求完成实验  
[Lab002](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab002.git)  

## 实验3顺序结构程序设计 

建议学时：1学时

**`实验目的`**
- 掌握C语言中使用最多的一种语句——赋值语句的使用方法。
- 掌握各种类型数据的输入输出的方法，能正确使用各种格式转换符。
- 进一步掌握编写程序和调试程序的方法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab003](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab003.git)  

## 实验4选择结构程序设计
建议学时：1学时

**`实验目的`**
- 了解C语言表示逻辑量的方法（以0代表“假”，以非0代表“真”）。
- 学会正确使用逻辑运算符和逻辑表达式。
- 熟练掌握if语句的使用（包括if语句的嵌套）。
- 熟练掌握多分支选择语句—switch语句。
- 结合程序掌握一些简单的算法。
- 进一步学习调试程序的方法。


**`实验任务`**

按照以下实验模板readme文件中的要求完成实验  
[Lab004](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab004.git)  

## 实验5循环结构程序设计
建议学时：1学时

**`实验目的`**
- 熟悉掌握用while语句、do…while语句和for语句实现循环的方法。
- 掌握在程序设计中用循环的方法实现一些常用算法（如穷举、迭代、递推等）。
- 进一步学习调试程序。


**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab005](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab005.git)  

## 实验6数组
建议学时：1学时

**`实验目的`**
- 掌握一维数组和二维数组的定义、赋值和输入输出的方法。
- 掌握字符数组和字符串函数的使用。
- 掌握与数组有关的算法（特别是排序算法）。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验  
[Lab006](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab006.git)  


## 实验7函数一
建议学时：1学时

**`实验目的`**
- 掌握定义函数的方法。
- 熟悉声明函数的方法。
- 熟悉调用函数时实参和形参的对应关系，以及“值传递”的方式。
- 学习对多文件的程序的编译和运行。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验  
[Lab007](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab007.git)  
  
## 实验8函数二
建议学时：1学时

**`实验目的`**
- 进一步熟悉怎样利用函数实现指定的任务。
- 熟悉函数的嵌套调用和递归调用的方法。
- 熟悉全局变量和局部变量的概念和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab008](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab008.git)  

## 实验9指针一
建议学时：1学时

**`实验目的`**
- 掌握指针和间接访问的概念，会定义和使用指针变量。
- 能正确使用数组的指针和指向数组的指针变量。
- 能正确使用字符串的指针和指向字符串的指针变量。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab009](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab009.git)  

## 实验10指针二
建议学时：1学时

**`实验目的`**
- 进一步掌握指针的应用。
- 能正确使用数组的指针和指向数组的指针变量。
- 能正确使用字符串的指针和指向字符串的指针变量。
- 了解指向指针的指针的用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab010](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab010.git)  

## 实验11自定义数据类型
建议学时：1学时

**`实验目的`**
- 掌握结构体类型变量的定义和使用。
- 掌握结构体类型数组的概念和使用。
- 了解链表的概念和操作方法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab011](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab011.git)  

## 实验12文件操作
建议学时：1学时

**`实验目的`**
- 了解文件和文件指针的概念。
- 学会使用文件操作函数实现对文件打开、关闭、读、写等操作。
- 学会对数据文件进行简单的操作。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab012](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab012.git)  

## 实验13预处理指令
建议学时：1学时

**`实验目的`**
- 了解预处理器的工作原理。
- 掌握预处理器的主要功能：宏定义、文件包含和条件编译。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验   
[Lab013](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab013.git)  

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab014](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab014.git)  
   
## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab015](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab015.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab016](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab016.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab017](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab017.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab018](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab018.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab019](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab019.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab020](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab020.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab021](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab021.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab022](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab022.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab023](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab023.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab024](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab024.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab025](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab025.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab026](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab026.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab027](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab027.git) 

## 实验14位运算  
建议学时：1学时  

**`实验目的`**
- 理解位运算并掌握各种位运算符的用法。
- 理解位段的含义和用法。

**`实验任务`**

按照以下实验模板readme文件中的要求完成实验    
[Lab028](https://www.codecode.net/engintime/ds-lab/Project-Template/Lab028.git) 


# 参考文献

`Coming soon`